#include <iostream>
#include <SDL.h>
#include <SDL_image.h>

const int SCREEN_WIDTH = 800;
const int SCREEN_HEIGTH = 600;

using namespace std;

int main(int argc, char *argv[])
{
  SDL_Surface *screen;

  if (SDL_Init(SDL_INIT_VIDEO /*|SDL_INIT_AUDIO*/) == -1) {
    cout << "Error initializing SDL" << endl;
  }

  screen = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGTH, 32, SDL_SWSURFACE|SDL_DOUBLEBUF);

  if (screen == NULL) {
    cout << "Error " << endl;
  }

  SDL_Surface *blue;
  blue = IMG_Load("blue.png");

  int blue_width = blue->w;
  int blue_heigth = blue->h;

  SDL_Surface *green = IMG_Load("green.png");


  SDL_Rect r;
  r.x = 5;
  r.y = 5;
  int xspeed = 10, yspeed = 10;

  int running = 1;
  while (running) {
    SDL_FillRect(screen, NULL, 0x000000);


    SDL_Event ev;

    while (SDL_PollEvent(&ev)) {
      if (ev.type == SDL_KEYDOWN) {
	if (ev.key.keysym.sym == SDLK_ESCAPE) {
	  running = 0;

	} else if (ev.key.keysym.sym == SDLK_x) {
	  xspeed = -xspeed;

	} else if (ev.key.keysym.sym == SDLK_y) {
	  yspeed = -yspeed;
	}
      } else if (ev.type == SDL_MOUSEMOTION) {
	SDL_Rect tmp;
	tmp.x = ev.motion.x - (blue_width/2);
	tmp.y = ev.motion.y - (blue_heigth/2);
	SDL_BlitSurface(green, NULL, screen, &tmp);
	
      } else if (ev.type == SDL_MOUSEBUTTONDOWN) {
	r.x = ev.button.x;
	r.y = ev.button.y;
      }
    }


    r.x += xspeed;
    r.y += yspeed;

    if (r.x + blue_width > SCREEN_WIDTH || r.x < 0) {
      xspeed = -xspeed;
    }

    if (r.y + blue_heigth > SCREEN_HEIGTH || r.y < 0) {
      yspeed = -yspeed;
    }

    SDL_BlitSurface(blue, NULL, screen, &r);

    SDL_Flip(screen);

    SDL_Delay(10);
  }

  SDL_FreeSurface(blue);
  SDL_FreeSurface(green);

  SDL_Quit();
  
  return 0;
}
